*-
*- zaslona ekranu z trajektoria
*- wykorzystuje BOX.ASM
*--
*- rej X  szerokosc
*- rej Y  wysokosc
*- komorki px, py to pozycja pozioma i pionowa
*--

scr48 equ %00111111	;obraz szeroki  *-screen 48b
scr40 equ %00111110	;obraz normalny *-screen 40b
scr32 equ %00111101	;obraz waski    *-screen 32b

pm equ $b000

ladr = $600
hadr = $680


Player0_PositionX equ $d000
Player1_PositionX equ $d001
Player2_PositionX equ $d002
Player3_PositionX equ $d003

Missile0_PositionX equ $d004
Missile1_PositionX equ $d005
Missile2_PositionX equ $d006
Missile3_PositionX equ $d007

Player0_Size equ $d008
Player1_Size equ $d009
Player2_Size equ $d00a
Player3_Size equ $d00b

Missiles_Size equ $d00c

Player0_Missile0_Color0_PM0 equ $d012
Player1_Missile1_Color1_PM1 equ $d013
Player2_Missile2_Color2_PM2 equ $d014
Player3_Missile3_Color3_PM3 equ $d015

Playfield_Color0_PF0 equ $d016
Playfield_Color1_PF1 equ $d017
Playfield_Color2_PF2 equ $d018
Playfield_Color3_PF3 equ $d019
Background_BAK       equ $d01a

PRIOR_GTIACTL equ $d01b
CHARBASE equ $d409

tim equ $14


px  equ $80
py  equ px+1
hlp equ py+1
pom equ hlp+2


main
 jsr ClearPMG

;- init PMG
 lda >pm
 sta $d407
 lda #3
 sta $d01d		;PMCTL - wyswietlac duchy i pociski
 lda #%00000000
 sta $d01b

 lda #$4
 sta Player0_Missile0_Color0_PM0
 sta 704
 sta Player1_Missile1_Color1_PM1
 sta 705
 sta Player2_Missile2_Color2_PM2
 sta 706
 sta Player3_Missile3_Color3_PM3
 sta 707

/*
 sei			;wylaczenie przerwan
 lda #0
 sta $d40e
 lda #$fe		;wylaczenie ROM-u
 sta $d301

 mwa #nmi $fffa
*/

 jsr init

*---
*---

start
; jsr ClearPmg
 
 lda #48
 sta px
 lda #120
 sta py

 lda #0
 sta frm+1
 lda #2
 sta ww+1
 
 lda #40
 sta py__+1
 mwa #faza1 fad+1
 
 rts

*---- let's go

loop jsr wait
fad jsr faza1

	rts
	
; jmp loop

*----

faza1
frm ldx #0         ; szerokosc
 lda tabx,x
 clc
 adc #42
 sta px
 lda taby,x
 clc
py__ adc #0
 sta py

ww lda #2          ; wysokosc
 asl @
 tay
 jsr box
 
 lda frm+1
 cmp #79-16
 bne skp
 mwa #faza2 fad+1
 
skp inc frm+1
 dec py__+1
 :2 inc ww+1
 rts

*---

faza2 ldx frm+1		;szer
 ldy #231		;wys
 jsr box
 
 lda frm+1
 cmp #79
 bcs sk0
 inc frm+1
 
sk0 dec py
 
; lda py
; cmp #5
; bne sk1
; jmp start
 
sk1 rts 

*---
wait
 lda:cmp:req tim
 rts


init mwa #tab hlp
 ldy #0
i00 lda hlp
 sta ladr,y
 lda hlp+1
 sta hadr,y
 
 lda hlp
 clc
 adc #14
 sta hlp
 bcc *+4
 inc hlp+1
 
 iny
 cpy #80
 bne i00
 rts


ClearPmg ldy #0
 tya
clr sta pm+$300,y
 sta pm+$400,y
 sta pm+$500,y
 sta pm+$600,y
 sta pm+$700,y
 iny
 bne clr
 rts
 
*--- BOX
box
 sty wys+1

 lda ladr,x
 sta hlp
 lda hadr,x
 sta hlp+1
 
 ldy #0
 lda (hlp),y
 sta Missiles_Size
 iny
 lda (hlp),y
 sta pom
 and #3
 sta Player0_Size
 lda pom
 :2 lsr @
 and #3
 sta Player1_Size
 lda pom
 :4 lsr @
 and #3
 sta Player2_Size
 lda pom
 :6 lsr @
 and #3
 sta Player3_Size
 
 iny
 lda (hlp),y
 sta f00+1
 iny
 lda (hlp),y
 sta f01+1
 iny
 lda (hlp),y
 sta f02+1
 iny
 lda (hlp),y
 sta f03+1
 iny
 lda (hlp),y
 sta f04+1
 
 jsr fill 
 
 iny
 lda px
 clc
; adc (hlp),y
 sta Missile0_PositionX
; iny
 adc (hlp),y
 sta Missile1_PositionX
 iny
 adc (hlp),y
 sta Missile2_PositionX
 iny
 adc (hlp),y
 sta Missile3_PositionX
 iny
 adc (hlp),y
 sta Player0_PositionX
 iny
 adc (hlp),y
 sta Player1_PositionX
 iny
 adc (hlp),y
 sta Player2_PositionX
 iny
 adc (hlp),y
 sta Player3_PositionX

wys ldy #0
 rts
 
err lda $d20a
 sta $d01a
 jmp err
 
*---
fill sty rY+1

 lda #0
 ldx #3
 ldy py
cl00 sta pm+$300-4,y
 sta pm+$400-4,y
 sta pm+$500-4,y
 sta pm+$600-4,y
 sta pm+$700-4,y
 iny
 dex
 bpl cl00

 ldy wys+1
 ldx py
 
f00 lda #0
 cpx #250
 bcs rY

 sta pm+$300,x
f01 lda #0
 sta pm+$400,x
f02 lda #0
 sta pm+$500,x
f03 lda #0
 sta pm+$600,x
f04 lda #0
 sta pm+$700,x
 inx
 dey
 bne f00

rY ldy #0
 rts

*---
/*
nmi pha
 sta $d40f
 
 inc tim
 
 lda #%00111100		;ustawienie szerokosci obrazu
 sta $d400

 lda #$c
 sta Player0_Missile0_Color0_PM0
 sta Player1_Missile1_Color1_PM1
 sta Player2_Missile2_Color2_PM2
 sta Player3_Missile3_Color3_PM3

 pla
 rti
*/
*---
*---
 .align

tabX ins 'track.dat',0,80
tabY ins 'track.dat',80,80

tab
 dta b(%00000000,%00000000)     ; szerokosci obiektow (pociski, sprity)
 dta b(%11,0,0,0,0)             ; wartosci ktorymi wypelnic obiekt
 dta b(2,0,0,0,0,0,0)           ; addycja pozycji X

 dta b(%00000000,%00000000)
 dta b(%1111,0,0,0,0)
 dta b(2,2,0,0,0,0,0)

 dta b(%00000000,%00000000)
 dta b(%111111,0,0,0,0)
 dta b(2,2,2,0,0,0,0)

 dta b(%00000000,%00000000)
 dta b(%11111111,0,0,0,0)
 dta b(2,2,2,2,0,0,0)

 dta b(%00000000,%00000000)
 dta b(%11111111,%11000000,0,0,0)
 dta b(2,2,2,2,0,0,0)

 dta b(%00000000,%00000000)
 dta b(%11111111,%11110000,0,0,0)
 dta b(2,2,2,2,0,0,0)

 dta b(%00000000,%00000000)
 dta b(%11111111,%11111100,0,0,0)
 dta b(2,2,2,2,0,0,0)

 dta b(%00000000,%00000000)
 dta b(%11111111,%11111111,0,0,0)
 dta b(2,2,2,2,0,0,0)

 dta b(%00000000,%00000000)
 dta b(%11111111,%11111111,%11000000,0,0)
 dta b(2,2,2,2,8,8,0)

; #9
 dta b(%00000000,%00000000)
 dta b(%11111111,%11111111,%11110000,0,0)
 dta b(2,2,2,2,8,0,0)

 dta b(%00000000,%00000000)
 dta b(%11111111,%11111111,%11111100,0,0)
 dta b(2,2,2,2,8,0,0)

 dta b(%00000000,%00000000)
 dta b(%11111111,%11111111,%11111111,0,0)
 dta b(2,2,2,2,8,8,0)

 dta b(%00000000,%00000000)
 dta b(%11111111,%11111111,%11111111,%11000000,0)
 dta b(2,2,2,2,8,8,0)

 dta b(%00000000,%00000000)
 dta b(%11111111,%11111111,%11111111,%11110000,0)
 dta b(2,2,2,2,8,8,0)

 dta b(%00000000,%00000000)
 dta b(%11111111,%11111111,%11111111,%11111100,0)
 dta b(2,2,2,2,8,8,0)

 dta b(%00000000,%00000000)
 dta b(%11111111,%11111111,%11111111,%11111111,0)
 dta b(2,2,2,2,8,8,8)

 dta b(%00000000,%00000000)
 dta b(%11111111,%11111111,%11111111,%11111111,%11000000)
 dta b(2,2,2,2,8,8,8)

 dta b(%00000000,%00000000)
 dta b(%11111111,%11111111,%11111111,%11111111,%11110000)
 dta b(2,2,2,2,8,8,8)

; #18
 dta b(%00000000,%00000000)
 dta b(%11111111,%11111111,%11111111,%11111111,%11111100)
 dta b(2,2,2,2,8,8,8)

 dta b(%00000000,%00000000)
 dta b(%11111111,%11111111,%11111111,%11111111,%11111111)
 dta b(2,2,2,2,8,8,8)

 dta b(%00000001,%00000000)
 dta b(%11111111,%11111111,%11111111,%11111111,%11111111)
 dta b(4,2,2,2,8,8,8)

 dta b(%00000101,%00000000)
 dta b(%11111111,%11111111,%11111111,%11111111,%11111111)
 dta b(4,4,2,2,8,8,8)

 dta b(%00010101,%00000000)
 dta b(%11111111,%11111111,%11111111,%11111111,%11111111)
 dta b(4,4,4,2,8,8,8)

 dta b(%01010101,%00000000)
 dta b(%11111111,%11111111,%11111111,%11111111,%11111111)
 dta b(4,4,4,4,8,8,8)

; #24
 dta b(%01011100,%00000000)
 dta b(%11111111,%11111111,%11111111,%11111111,%11111111)
 dta b(2,8,4,4,8,8,8)

 dta b(%01011101,%00000000)
 dta b(%11111111,%11111111,%11111111,%11111111,%11111111)
 dta b(4,8,4,4,8,8,8)

 dta b(%11001101,%00000000)
 dta b(%11111111,%11111111,%11111111,%11111111,%11111111)
 dta b(4,8,2,8,8,8,8)

 dta b(%11011101,%00000000)
 dta b(%11111111,%11111111,%11111111,%11111111,%11111111)
 dta b(4,8,4,8,8,8,8)

; 28
 dta b(%00111111,%00000000)
 dta b(%11111111,%11111111,%11111111,%11111111,%11111111)
 dta b(8,8,8,2,8,8,8)

 dta b(%01111111,%00000000)
 dta b(%11111111,%11111111,%11111111,%11111111,%11111111)
 dta b(8,8,8,4,8,8,8)

 dta b(%00111101,%00000001)
 dta b($ff,$ff,$ff,$ff,$ff)
 dta b(4,8,8,2,16,8,8)

 dta b(%11111111,%00000011)
 dta b(%11111111,$ff,0,0,0)
 dta b(8,8,8,8,32,0,0)

 dta b(%11111111,%00000011)
 dta b(%11111111,$ff,%11000000,0,0)
 dta b(8,8,8,8,32,0,0)

 dta b(%11111111,%00000011)
 dta b(%11111111,$ff,%11110000,0,0)
 dta b(8,8,8,8,32,0,0)

 dta b(%11111111,%00000011)
 dta b(%11111111,$ff,%11111100,0,0)
 dta b(8,8,8,8,32,0,0)

 dta b(%11111111,%00000011)
 dta b(%11111111,$ff,%11111111,0,0)
 dta b(8,8,8,8,32,0,0)

; 36
 dta b(%11111111,%00000011)
 dta b(%11111111,$ff,%11111111,%11000000,0)
 dta b(8,8,8,8,32,8,0)

 dta b(%11111111,%00000011)
 dta b(%11111111,$ff,%11111111,%11110000,0)
 dta b(8,8,8,8,32,8,0)

 dta b(%11111111,%00000011)
 dta b(%11111111,$ff,%11111111,%11111100,0)
 dta b(8,8,8,8,32,8,0)

 dta b(%11111111,%00000011)
 dta b(%11111111,$ff,%11111111,%11111111,0)
 dta b(8,8,8,8,32,8,0)

; 40
 dta b(%11111111,%00000011)
 dta b(%11111111,$ff,%11111111,%11111111,%11000000)
 dta b(8,8,8,8,32,8,8)

 dta b(%11111111,%00000011)
 dta b(%11111111,$ff,%11111111,%11111111,%11110000)
 dta b(8,8,8,8,32,8,8)

 dta b(%11111111,%00000011)
 dta b(%11111111,$ff,%11111111,%11111111,%11111100)
 dta b(8,8,8,8,32,8,8)

 dta b(%11111111,%00000011)
 dta b(%11111111,$ff,%11111111,%11111111,%11111111)
 dta b(8,8,8,8,32,8,8)

 dta b(%11111111,%00000111)
 dta b(%11111111,$ff,$ff,$ff,%11000000)
 dta b(8,8,8,8,32,16,8)

 dta b(%11111111,%00000111)
 dta b(%11111111,$ff,$ff,$ff,%11110000)
 dta b(8,8,8,8,32,16,8)

 dta b(%11111111,%00000111)
 dta b(%11111111,$ff,$ff,$ff,%11111100)
 dta b(8,8,8,8,32,16,8)

 dta b(%11111111,%00000111)
 dta b(%11111111,$ff,$ff,$ff,%11111111)
 dta b(8,8,8,8,32,16,8)

 dta b(%11111111,%00001111)
 dta b(%11111111,$ff,$ff,%11000000,0)
 dta b(8,8,8,8,32,32,0)

 dta b(%11111111,%00001111)
 dta b(%11111111,$ff,$ff,%11110000,0)
 dta b(8,8,8,8,32,32,0)

; 50
 dta b(%11111111,%00001111)
 dta b(%11111111,$ff,$ff,%11111100,0)
 dta b(8,8,8,8,32,32,0)

 dta b(%11111111,%00001111)
 dta b(%11111111,$ff,$ff,%11111111,0)
 dta b(8,8,8,8,32,32,0)

 dta b(%11111111,%00001111)
 dta b(%11111111,$ff,$ff,$ff,%11000000)
 dta b(8,8,8,8,32,32,8)

 dta b(%11111111,%00001111)
 dta b(%11111111,$ff,$ff,$ff,%11110000)
 dta b(8,8,8,8,32,32,8)

 dta b(%11111111,%00001111)
 dta b(%11111111,$ff,$ff,$ff,%11111100)
 dta b(8,8,8,8,32,32,8)

 dta b(%11111111,%00001111)
 dta b(%11111111,$ff,$ff,$ff,%11111111)
 dta b(8,8,8,8,32,32,8)

 dta b(%11111111,%00011111)
 dta b(%11111111,$ff,$ff,$ff,%11000000)
 dta b(8,8,8,8,32,32,16)

 dta b(%11111111,%00011111)
 dta b(%11111111,$ff,$ff,$ff,%11110000)
 dta b(8,8,8,8,32,32,16)

 dta b(%11111111,%00011111)
 dta b(%11111111,$ff,$ff,$ff,%11111100)
 dta b(8,8,8,8,32,32,16)

 dta b(%11111111,%00011111)
 dta b(%11111111,$ff,$ff,$ff,%11111111)
 dta b(8,8,8,8,32,32,16)

; 60
 dta b(%11111111,%01011111)
 dta b(%11111111,$ff,$ff,$ff,%11111000)
 dta b(8,8,8,8,32,32,16)

 dta b(%11111111,%01011111)
 dta b(%11111111,$ff,$ff,$ff,%11111100)
 dta b(8,8,8,8,32,32,16)

 dta b(%11111111,%01011111)
 dta b(%11111111,$ff,$ff,$ff,%11111110)
 dta b(8,8,8,8,32,32,16)

 dta b(%11111111,%01011111)
 dta b(%11111111,$ff,$ff,$ff,%11111111)
 dta b(8,8,8,8,32,32,16)

 dta b(%11111111,%01111111)
 dta b(%11111111,$ff,$ff,$ff,%10000000)
 dta b(8,8,8,8,32,32,32)

 dta b(%11111111,%01111111)
 dta b(%11111111,$ff,$ff,$ff,%11000000)
 dta b(8,8,8,8,32,32,32)

 dta b(%11111111,%01111111)
 dta b(%11111111,$ff,$ff,$ff,%11100000)
 dta b(8,8,8,8,32,32,32)

 dta b(%11111111,%01111111)
 dta b(%11111111,$ff,$ff,$ff,%11110000)
 dta b(8,8,8,8,32,32,32)

 dta b(%11111111,%01111111)
 dta b(%11111111,$ff,$ff,$ff,%11111000)
 dta b(8,8,8,8,32,32,32)

 dta b(%11111111,%01111111)
 dta b(%11111111,$ff,$ff,$ff,%11111100)
 dta b(8,8,8,8,32,32,32)

; 70
 dta b(%11111111,%01111111)
 dta b(%11111111,$ff,$ff,$ff,%11111110)
 dta b(8,8,8,8,32,32,32)

 dta b(%11111111,%01111111)
 dta b(%11111111,$ff,$ff,$ff,$ff)
 dta b(8,8,8,8,32,32,32)

 dta b(%11111111,%11111111)
 dta b(%11111111,$ff,$ff,$ff,%11111000)
 dta b(8,8,8,8,32,30,32)

 dta b(%11111111,%11111111)
 dta b(%11111111,$ff,$ff,$ff,%11111100)
 dta b(8,8,8,8,32,30,30)

 dta b(%11111111,%11111111)
 dta b(%11111111,$ff,$ff,$ff,%11111100)
 dta b(8,8,8,8,32,30,32)

 dta b(%11111111,%11111111)
 dta b(%11111111,$ff,$ff,$ff,%11111100)
 dta b(8,8,8,8,32,32,32)

 dta b(%11111111,%11111111)
 dta b(%11111111,$ff,$ff,$ff,%11111110)
 dta b(8,8,8,8,32,32,30)

 dta b(%11111111,%11111111)
 dta b(%11111111,$ff,$ff,$ff,%11111110)
 dta b(8,8,8,8,32,32,32)

 dta b(%11111111,%11111111)
 dta b(%11111111,$ff,$ff,$ff,$ff)
 dta b(8,8,8,8,32,32,30)

; 79
 dta b(%11111111,%11111111)
 dta b(%11111111,$ff,$ff,$ff,$ff)
 dta b(8,8,8,8,32,32,32)

*---
