
/*---------------------------------------------------------------------------------------------------------------
	GENERUJEMY KOLORY NA ZNAKACH
---------------------------------------------------------------------------------------------------------------*/
.local	pal_init

	ldx #0

lp	ldy #0
	lda tc0,y
	jsr fill

	ldy lp+1
	lda tc1,y
	jsr fill
	
	inc lp+1
	lda lp+1
	cmp #16
	bne lp
	
	rts

fill	ldy #3
@	sta fnt+1024*0,x
	sta fnt+1024*1,x
	sta fnt+1024*2,x
	sta fnt+1024*3,x
	sta fnt+1024*4,x
	inx
	dey
	bpl @-
	rts

tc0	.he 00 00 00 00 55 55 55 55 aa aa aa aa ff ff ff ff
tc1	.he 00 55 aa ff 00 55 aa ff 00 55 aa ff 00 55 aa ff
.endl


/*---------------------------------------------------------------------------------------------------------------
	GENERUJEMY TUNEL
---------------------------------------------------------------------------------------------------------------*/

.local	tunel

	lda #0
cnt	equ *-1
	cmp #33
	sne
	mva #0 cnt

	asl @
	
	sta _jmp+1

	inc cnt
	
	inc calc.adx
	inc calc.ady

_jmp	jmp (drawTnl)


	.rept 33,#
	.def draw_col:1
	calc #calc.col:1.u #calc.col:1.v
	jmp col:1
	.endr

.endl

.macro	chunky px,py,c0,c1
	lda colors+:c0
	asl @
	asl @
	ora colors+:c1
	sta scr+:px+:py*40+4*40
.endm

.macro slow
.endm

	icl 'mtnl.asm'

.proc	calc (.word u,v) .var

	mva #43-1 loop+1
	
loop	ldx #0

	ldy $ffff,x
u	equ *-2

	lda $ffff,x
v	equ *-2
	tax

	lda mod48,y
adx	equ *-2
	tay

	lda mod32,x
ady	equ *-2
	tax

	mva ltex,x tex
	mva htex,x tex+1

	lda $ffff,y
tex	equ *-2

	ldy loop+1
	sta colors,y
	
	dec loop+1
	bpl loop

	rts

	icl 'tnl.asm'
	
ltex	:32 dta l(texture+#*48)
htex	:32 dta h(texture+#*48)

texture	ins 'texture.dat'
.endp

